/**
 * 
 * @author sameh
 *
 * @param <E>
 */
public class BetterArray<E> {

	/**
	 * ;lksdjf;laksdfj d
	 */
	private static final int DEFAULT_ARRAY_SIZE = 100;
	
	/**
	 *  asdlkfj sdlkjflkj lsdkjf assdf
	 */
	private E[] myArray;
	
	/**
	 *  ;lkasdjf;lkasdjf ;laksdj f;laksdjfg 
	 */
	private int numElements = 0;

	//
	
	/* */
	
	
	/**
	 * 
	 * This is the default constructor for this class
	 * 
	 */
	public BetterArray() {
		myArray = (E[]) new Object[DEFAULT_ARRAY_SIZE];
	}
	
	/**
	 * 
	 * this constructor creates an array of the specified size
	 * 
	 * @param size	the size of the array to start out
	 */
	public BetterArray(int size) {
		if (size > 0) {
			myArray = (E[]) new Object[size];
		} else {
			myArray = (E[]) new Object[DEFAULT_ARRAY_SIZE];
		}
	}
	
	
	public int size() {
		return this.numElements;
	}
	
	/**
	 * 
	 * @param element
	 */
	public void add(E element) {
		if (this.numElements == this.myArray.length) {
			this.makeMyArrayLarger();
		}
		this.myArray[this.numElements++] = element;
	}

	
	public void add(E element, int index) {
		if (index >= 0) {
			if (this.numElements == this.myArray.length) {
				this.makeMyArrayLarger();
			}
			
			if (index == this.numElements) {
				this.myArray[index] = element;
			} else if (index < this.numElements) {
				for ( int i = numElements ; i > index ; i-- ) {
					this.myArray[i] = this.myArray[i-1];
				}
				this.myArray[index] = element;
				this.numElements++;
			}
		}
	}

	/**
	 * method to get the element at the specified index
	 * 
	 * @param index this index of the desired element
	 * @return The element at the specified index, <B>null</B> if index is not valid
	 */
	public E get(int index) {
		if ((index >= 0) && (index < this.numElements)) {
			return this.myArray[index];
		}
		return null;
	}

	// 0 1 2 3 4 5 6 7 8 9 
	// a b c d e  
	// numElements = 5
	// index = 1
	
	public E remove(int index) {
		E returnValue = null;
		
		if ((index >= 0) && (this.numElements > 0) && (index < this.numElements)) {
			returnValue = this.myArray[index];
			
			if (index != this.numElements - 1) {
				for ( int i = index ; i < this.numElements - 1 ; i++ ) {
					this.myArray[i] = this.myArray[i+1];
				}
			}
			
			this.numElements--;
		} else {
			return null;
		}
		
		return returnValue;
	}
	
	
	private void makeMyArrayLarger() {
		E[] newArray = (E[]) new Object[this.myArray.length + DEFAULT_ARRAY_SIZE];
		for ( int i = 0 ; i < this.myArray.length ; i++ ) {
			newArray[i] = this.myArray[i];
		}
		this.myArray = newArray;
	}


	@Override
	public String toString() {
		String output = "myArray = [";

		for ( int i = 0 ; i < this.numElements ; i++ ) {
			output = output + this.myArray[i];
			if ( i != this.numElements - 1) {
				output = output + ", ";
			} else {
				output = output + "]";
			}
		}

		return output;
	}
	
}
